import random
from typing import Any

import pandas as pd

from uncommonport.detector.config import Config


class Const:
    # general
    TENANT_ORG_ID = "TENANT_ORG_ID"

    # dimension
    TIMESTAMP = "timestamp"
    SRC_VM_ID = "srcVmId"
    DST_VM_ID = "dstVmId"
    DST_PORT = "dstPort"
    PROTOCOL = "protocol"
    APP_ID = "appId"
    DST_INSECURE_APP_VERSION = "dstInsecureAppVersion"
    IS_SRC_L7_RULE_HIT = "isSrcL7RuleHit"
    IS_DST_L7_RULE_HIT = "isDstL7RuleHit"
    SRC_APP_PORT_MISMATCHED = "srcAppPortMismatched"
    DST_APP_PORT_MISMATCHED = "dstAppPortMismatched"
    SRC_SITE_ID = "srcSiteId"
    DST_SITE_ID = "dstSiteId"
    SRC_COMPUTE_TYPE = "srcComputeType"
    DST_COMPUTE_TYPE = "dstComputeType"
    VM_COMPUTE_TYPE = "VM"
    IS_SILENT = "is_silent"
    LAST_START_TIME = "lastStartTime"
    LAST_END_TIME = "lastEndTime"

    # score
    DEFAULT_SCORE_VALUE = 2
    DEFAULT_SCORE = 50
    DEFAULT_VM_COUNT = 20
    VM_COUNT_QUADRATIC_COEFFICIENT = DEFAULT_SCORE * DEFAULT_SCORE / DEFAULT_VM_COUNT
    MAX_SCORE = 100

    # Event
    NSX_I = "NSX_I"

    # other
    APP_NAME = "app_name"
    UNKNOWN_APP_DISPLAY_NAME = "Unknown App Name"
    IS_PORT_EXPECTED = "is_port_expected"
    UNKNOWN_APP_EXPECTED_PORTS = []
    MAX_CHECKPOINT_INTERVAL_IN_DAYS = 10

    # pandas df agg function names
    AGG_FIRST = "first"

    # pandas custom agg functions
    @staticmethod
    def AGG_LIST_TRANSFORM(x: pd.Series) -> list[Any]:
        return list(x)

    @staticmethod
    def AGG_LIST_TRANSFORM_WITH_LIMIT_WITHOUT_DUP(x: pd.Series) -> list[Any]:
        list_without_dups = list(set(x))
        size_limit = int(Config.AGG_SET_TRANSFORM_LIMIT)

        if len(list_without_dups) > size_limit:
            return random.sample(list_without_dups, size_limit)
        return list_without_dups
